X.509 Certificate Extended Key Usage (EKU) for Instant Messaging URIs
RFC 9734
Rohan Mahy
Rohan Mahy Consulting Services
2025-02
SEC
lamps
x.509
certificate
extended key usage
eku
instant messaging
im URI
mimi URL
RFC 5280 specifies several extended key purpose identifiers (KeyPurposeIds) for X.509 certificates. This document defines an Instant Messaging (IM) identity KeyPurposeId for inclusion in the Extended Key Usage (EKU) extension of X.509 v3 public key certificates
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc9734.
Copyright Notice
Copyright (c) 2025 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Revised BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Revised BSD License.
Table of Contents
- 1. Introduction
- 2. Conventions and Definitions
- 3. The IM URI EKU
- 4. Security Considerations
- 5. IANA Considerations
- 6. References
  - 6.1. Normative References
  - 6.2. Informative References
- Appendix A. ASN.1 Module
- Acknowledgments
- Author's Address
Introduction
Instant Messaging (IM) systems using the Messaging Layer Security (MLS) [RFC9420] protocol can incorporate per-client identity certificate credentials. A subjectAltName in these certificates can be an IM URI [RFC3860] or Extensible Messaging and Presence Protocol (XMPP) URI [RFC6121], for example.
Organizations may be unwilling to issue certificates for an IM client using a general KeyPurposeId, such as id-kp-serverAuth or id-kp-clientAuth, because of the risk that such certificates could be abused in a cross-protocol attack.
An explanation of MLS credentials as they apply to IM is described in [E2E-IDENTITY]. These credentials are expected to be heavily used in the More Instant Messaging Interoperability (MIMI) Working Group.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The IM URI EKU
This specification defines the KeyPurposeId id-kp-imUri, which may be included in certificates used to prove the identity of an IM client. This EKU extension MAY, at the option of the certificate issuer, be either critical or non-critical.

id-kp  OBJECT IDENTIFIER  ::= {
  iso(1) identified-organization(3) dod(6) internet(1)
  security(5) mechanisms(5) pkix(7) kp(3) }

id-kp-imUri OBJECT IDENTIFIER ::= { id-kp 40 }
Security Considerations
The security considerations of [RFC5280] are applicable to this document. The id-kp-imUri extended key purpose does not introduce new security risks but instead reduces existing security risks by providing means to identify if the certificate is generated to sign IM identity credentials. Issuers SHOULD NOT set the id-kp-imUri extended key purpose and an id-kp-clientAuth or id-kp-serverAuth extended key purpose: that would defeat the improved specificity offered by having an id-kp-imUri extended key purpose.
IANA Considerations
IANA has registered the following OID in the "SMI Security for PKIX Extended Key Purpose" registry (1.3.6.1.5.5.7.3). This OID is defined in Section 3.
Decimal | Description | References
40 | id-kp-imUri | RFC 9734
IANA has also registered the following ASN.1 [ITU.X690.2021] module OID in the "SMI Security for PKIX Module Identifier" registry (1.3.6.1.5.5.7.0). This OID is defined in Appendix A.
Decimal | Description | References
113 | id-mod-im-eku | RFC 9734
References
Normative References
[ITU.X680.2021]

Information Technology - Abstract Syntax Notation One (ASN.1): Specification of basic notation
ITU-T
February 2021
ITU-T Recommendation X.680
ISO/IEC 8824-1:2021
[ITU.X690.2021]

Information Technology - ASN.1 encoding rules: Specification of Basic Encoding Rules (BER), Canonical Encoding Rules (CER) and Distinguished Encoding Rules (DER)
ITU-T
February 2021
ITU-T Recommendation X.690
ISO/IEC 8825-1-2021
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC5280]

Internet X.509 Public Key Infrastructure Certificate and Certificate Revocation List (CRL) Profile
D. Cooper
S. Santesson
S. Farrell
S. Boeyen
R. Housley
W. Polk
May 2008
RFC 5280
DOI 10.17487/RFC5280
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[I-D.barnes-mimi-identity-arch]

Identity for E2E-Secure Communications
Richard Barnes
Cisco
Rohan Mahy
Rohan Mahy Consulting Service
4 February 2025
Internet-Draft draft-barnes-mimi-identity-arch-02
Work in Progress
[RFC3860]

Common Profile for Instant Messaging (CPIM)
J. Peterson
August 2004
RFC 3860
DOI 10.17487/RFC3860
[RFC6121]

Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence
P. Saint-Andre
March 2011
RFC 6121
DOI 10.17487/RFC6121
[RFC9420]

The Messaging Layer Security (MLS) Protocol
R. Barnes
B. Beurdouche
R. Robert
J. Millican
E. Omara
K. Cohn-Gordon
July 2023
RFC 9420
DOI 10.17487/RFC9420
ASN.1 Module
The following module adheres to ASN.1 specifications [ITU.X680.2021] and [ITU.X690.2021].

<CODE BEGINS>

IM-EKU
  { iso(1) identified-organization(3) dod(6) internet(1)
  security(5) mechanisms(5) pkix(7) id-mod(0)
  id-mod-im-eku (113) }

DEFINITIONS IMPLICIT TAGS ::=
BEGIN

-- OID Arc

id-kp OBJECT IDENTIFIER ::=
  { iso(1) identified-organization(3) dod(6) internet(1)
    security(5) mechanisms(5) pkix(7) kp(3) }

-- Extended Key Usage Values

id-kp-imUri OBJECT IDENTIFIER ::= { id-kp 40 }

END

<CODE ENDS>
Acknowledgments
Thanks to Sean Turner and Russ Housley for reviews, suggestions, corrections, and encouragement.
Author's Address
Rohan Mahy
Rohan Mahy Consulting Services
rohan.ietf@gmail.com